import { StringType, StringTypeRequired, BooleanType, BooleanTypeRequired, NumberType, NumberTypeRequired, FileType, FileTypeRequired, EnumTypeRequired, EnumType, ExtractTypes, All, ObjectType, ObjectTypeRequired, FType2type, ArrayType, ArrayTypeRequired, MixedTypeRequired, MixedType, NullType, AnyTypeRequired, AnyType } from "./FieldTypes";
export declare function Str(required: true, defaultValue?: string): StringTypeRequired;
export declare function Str(required?: false, defaultValue?: string): StringType;
export declare function Num(required: true, defaultValue?: number): NumberTypeRequired;
export declare function Num(required?: false, defaultValue?: number): NumberType;
export declare function Bool(required: true, defaultValue?: boolean): BooleanTypeRequired;
export declare function Bool(required?: false, defaultValue?: boolean): BooleanType;
export declare function FileField(required: true, defaultValue?: File): FileTypeRequired;
export declare function FileField(required?: false, defaultValue?: File): FileType;
export declare function Enum<Variants extends any[]>(variants: Variants, required: true, defaultValue?: Variants[number]): EnumTypeRequired<Variants>;
export declare function Enum<Variants extends any[]>(variants: Variants, required?: false, defaultValue?: Variants[number]): EnumType<Variants>;
export declare function Obj<DataType extends {
    [key: string]: All;
}>(fields: DataType, required: true, defaultValue?: ExtractTypes<DataType>): ObjectTypeRequired<DataType>;
export declare function Obj<DataType extends {
    [key: string]: All;
}>(fields: DataType, required?: false, defaultValue?: ExtractTypes<DataType>): ObjectType<DataType>;
export declare function Arr<Children extends All>(childrenType: Children, required: true, defaultValue?: Array<FType2type<Children>>): ArrayTypeRequired<Children>;
export declare function Arr<Children extends All>(childrenType: Children, required?: false, defaultValue?: Array<FType2type<Children>>): ArrayType<Children>;
export declare function Mix<Mixed extends All[]>(mixed: Mixed, required: true, defaultValue?: FType2type<Mixed[number]>): MixedTypeRequired<Mixed>;
export declare function Mix<Mixed extends All[]>(mixed: Mixed, required?: false, defaultValue?: FType2type<Mixed[number]>): MixedType<Mixed>;
export declare function Null(): NullType;
export declare function Any<DataType = undefined>(required: true, defaultValue?: DataType): AnyTypeRequired<DataType>;
export declare function Any<DataType = undefined>(required?: false, defaultValue?: DataType): AnyType<DataType>;
