"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Any = exports.Null = exports.Mix = exports.Arr = exports.Obj = exports.Enum = exports.FileField = exports.Bool = exports.Num = exports.Str = void 0;
function Str(required, defaultValue) {
    return {
        type: "string",
        required: Boolean(required),
        default: defaultValue
    };
}
exports.Str = Str;
function Num(required, defaultValue) {
    return {
        type: "number",
        required: Boolean(required),
        default: defaultValue
    };
}
exports.Num = Num;
function Bool(required, defaultValue) {
    return {
        type: "boolean",
        required: Boolean(required),
        default: defaultValue
    };
}
exports.Bool = Bool;
function FileField(required, defaultValue) {
    return {
        type: "file",
        required: Boolean(required),
        default: defaultValue
    };
}
exports.FileField = FileField;
function Enum(variants, required, defaultValue) {
    return {
        type: "enum",
        variants,
        required: Boolean(required),
        default: defaultValue
    };
}
exports.Enum = Enum;
function Obj(fields, required, defaultValue) {
    return {
        type: "object",
        fields,
        required: Boolean(required),
        default: defaultValue
    };
}
exports.Obj = Obj;
function Arr(childrenType, required, defaultValue) {
    return {
        default: defaultValue,
        type: "array",
        consistsOf: childrenType,
        required: Boolean(required)
    };
}
exports.Arr = Arr;
function Mix(mixed, required, defaultValue) {
    return {
        default: defaultValue,
        type: "mixed",
        mix: mixed,
        required: Boolean(required)
    };
}
exports.Mix = Mix;
function Null() {
    return {
        type: "null",
        required: false,
        default: null
    };
}
exports.Null = Null;
function Any(required, defaultValue) {
    return {
        type: "any",
        required: Boolean(required),
        default: defaultValue
    };
}
exports.Any = Any;
//# sourceMappingURL=FieldTypesCreators.js.map