import { All, FType2type } from "./FieldTypes";
import { StoreType, ControllerConfig, Errors as Errs } from "./types";
import { ValueStorage } from "./Models/ValueStorage";
import { Errors } from "./Models/Errors";
export declare class FormController<FileldsTypes extends {
    [key: string]: All;
}, SubmitArgs extends any[]> {
    private config;
    private values;
    private guards;
    private validators;
    errors: Errors<FileldsTypes>;
    constructor(config: ControllerConfig<FileldsTypes, SubmitArgs>);
    set<K extends keyof FileldsTypes>(name: K, value: FType2type<FileldsTypes[K]>): void;
    get<K extends keyof FileldsTypes>(name: K): FType2type<FileldsTypes[K]> | undefined;
    change(name: string, nextValue: any): void;
    getValues(): Partial<StoreType<FileldsTypes>>;
    submit(...arg: SubmitArgs): void | Errs<FileldsTypes>;
    subscribe(type: "errors", cb: Parameters<Errors<FileldsTypes>["subscribe"]>[0]): ReturnType<Errors<FileldsTypes>["subscribe"]>;
    subscribe(type: "values", cb: Parameters<ValueStorage<FileldsTypes>["subscribe"]>[0]): ReturnType<ValueStorage<FileldsTypes>["subscribe"]>;
}
