"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdvancedObservable = void 0;
class AdvancedObservable {
    constructor() {
        this.subs = [];
    }
    update(message) {
        this.subs.forEach(i => i(message));
    }
    subscribe(cb) {
        this.subs.push(cb);
        this.onSubscribe && this.onSubscribe(this.subs.length);
        return {
            unsubscribe: () => {
                this.subs.splice(this.subs.indexOf(cb), 1);
                this.onUnsubscribe && this.onUnsubscribe(this.subs.length);
            }
        };
    }
    size() {
        return this.subs.length;
    }
}
exports.AdvancedObservable = AdvancedObservable;
//# sourceMappingURL=AdvancedObservable.js.map