import { AdvancedObservable } from "./AdvancedObservable";
import { All, FType2type } from "../FieldTypes";
import { StoreType } from "../types";
export declare class ValueStorage<Fields extends {
    [key: string]: All;
}> {
    private subs;
    private value;
    constructor(fields: Fields);
    set<K extends keyof Fields>(name: K, value: FType2type<Fields[K]>): void;
    get<K extends keyof Fields>(name: K): FType2type<Fields[K]> | undefined;
    getState(): Partial<StoreType<Fields>>;
    subscribe: AdvancedObservable<Partial<StoreType<Fields>>>["subscribe"];
}
