"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValueStorage = void 0;
const AdvancedObservable_1 = require("./AdvancedObservable");
class ValueStorage {
    constructor(fields) {
        this.subs = new AdvancedObservable_1.AdvancedObservable();
        this.value = {};
        this.subscribe = this.subs.subscribe.bind(this.subs);
        for (let key in fields) {
            if (fields[key].default)
                this.value[key] = fields[key].default;
            else if (fields[key].type === "string")
                this.value[key] = "";
            else if (fields[key].type === "number")
                this.value[key] = "";
        }
    }
    set(name, value) {
        this.value[name] = value;
        this.subs.update(this.value);
    }
    get(name) {
        return this.value[name];
    }
    getState() {
        return this.value;
    }
}
exports.ValueStorage = ValueStorage;
//# sourceMappingURL=ValueStorage.js.map