import { FType2type, All } from "./FieldTypes";
export declare type Errors<FieldTypes extends {
    [key: string]: any;
}> = {
    [K in keyof FieldTypes]?: string;
};
export declare type StoreType<FileldsTypes extends {
    [key: string]: All;
}> = {
    [K in keyof FileldsTypes]: FType2type<FileldsTypes[K]>;
};
export declare type ValidatorFunction<T, FT> = (value: T, store: FT) => void | Error;
export declare type Validator<FileldsTypes extends {
    [key: string]: All;
}> = {
    [K in keyof FileldsTypes]?: ValidatorFunction<FType2type<FileldsTypes[K]>, Partial<StoreType<FileldsTypes>>>;
};
export declare type GuardFunction<RT> = (value: any) => RT | Error;
export declare type Guards<FileldsTypes extends {
    [key: string]: All;
}> = {
    [K in keyof FileldsTypes]: GuardFunction<FType2type<FileldsTypes[K]>>;
};
export declare type ControllerConfig<FileldsTypes extends {
    [key: string]: All;
}, SubmitArg extends any[] = void[]> = {
    fields: FileldsTypes;
    validators?: Validator<FileldsTypes>;
    guards?: Guards<FileldsTypes>;
    submit?: (store: StoreType<FileldsTypes>, ...args: SubmitArg) => void | Errors<FileldsTypes> | Promise<void | Errors<FileldsTypes>>;
};
